package main

import (
  "vigil/internal/bot"
  "vigil/pkg/config"
  "fmt"
  "os"
)

func main() {
  // Open config file
  f, err := os.OpenFile("vigil.yaml", os.O_RDWR|os.O_CREATE, 0755)
  if err != nil {
    fmt.Println(err)
    return
  }

  // Load config data
  c, err := config.Load(f)
  if err != nil {
    fmt.Println(err)
    return
  }

  // Save config data
  _, err = f.Seek(0, 0)
  if err != nil {
    fmt.Println(err)
  }

  err = config.Save(f, c)
  if err != nil {
    fmt.Println(err)
  }

  // Run bot
  if err := bot.Run(c); err != nil {
    fmt.Println(err)
  }
}
